---
title: WebGLShader
slug: Web/API/WebGLShader
tags:
  - Reference
  - WebGL
  - WebGLShader
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong>WebGLShader</strong> is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and can either be a vertex or a fragment shader. A {{domxref("WebGLProgram")}} requires both types of shaders.</p>

<h2 id="Description">Description</h2>

<p>To create a <strong>WebGLShader</strong> use {{domxref("WebGLRenderingContext.createShader")}}, then hook up the GLSL source code using {{domxref("WebGLRenderingContext.shaderSource()")}}, and finally invoke {{domxref("WebGLRenderingContext.compileShader()")}} to finish and compile the shader. At this point the <strong>WebGLShader</strong> is still not in a usable form and must still be attached to a {{domxref("WebGLProgram")}}.</p>

<pre class="brush: js">function createShader (gl, sourceCode, type) {
  // Compiles either a shader of type gl.VERTEX_SHADER or gl.FRAGMENT_SHADER
  var shader = gl.createShader( type );
  gl.shaderSource( shader, sourceCode );
  gl.compileShader( shader );

  if ( !gl.getShaderParameter(shader, gl.COMPILE_STATUS) ) {
    var info = gl.getShaderInfoLog( shader );
    throw 'Could not compile WebGL program. \n\n' + info;
  }
  return shader;
}
</pre>

<p>See {{domxref("WebGLProgram")}} for information on attaching the shaders.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_a_vertex_shader">Creating a vertex shader</h3>

<p>Note that there are many other strategies for writing and accessing shader source code strings. These example are for illustration purposes only.</p>

<pre class="brush: js">var vertexShaderSource =
  'attribute vec4 position;\n' +
  'void main() {\n' +
  '  gl_Position = position;\n' +
  '}\n';

//Use the createShader function from the example above
var vertexShader = createShader(gl, vertexShaderSource, gl.VERTEX_SHADER)
</pre>

<h3 id="Creating_a_fragment_shader">Creating a fragment shader</h3>

<pre class="brush: js">var fragmentShaderSource =
  'void main() {\n' +
  '  gl_FragColor = vec4(1.0, 1.0, 1.0, 1.0);\n' +
  '}\n';

//Use the createShader function from the example above
var fragmentShader = createShader(gl, fragmentShaderSource, gl.FRAGMENT_SHADER)
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('WebGL', "#5.8", "WebGLShader")}}</td>
			<td>{{Spec2('WebGL')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLShader")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("WebGLProgram")}}</li>
	<li>{{domxref("WebGLRenderingContext.attachShader()")}}</li>
	<li>{{domxref("WebGLRenderingContext.bindAttribLocation()")}}</li>
	<li>{{domxref("WebGLRenderingContext.compileShader()")}}</li>
	<li>{{domxref("WebGLRenderingContext.createProgram()")}}</li>
	<li>{{domxref("WebGLRenderingContext.createShader()")}}</li>
	<li>{{domxref("WebGLRenderingContext.deleteProgram()")}}</li>
	<li>{{domxref("WebGLRenderingContext.deleteShader()")}}</li>
	<li>{{domxref("WebGLRenderingContext.detachShader()")}}</li>
	<li>{{domxref("WebGLRenderingContext.getAttachedShaders()")}}</li>
	<li>{{domxref("WebGLRenderingContext.getProgramParameter()")}}</li>
	<li>{{domxref("WebGLRenderingContext.getProgramInfoLog()")}}</li>
	<li>{{domxref("WebGLRenderingContext.getShaderParameter()")}}</li>
	<li>{{domxref("WebGLRenderingContext.getShaderPrecisionFormat()")}}</li>
	<li>{{domxref("WebGLRenderingContext.getShaderInfoLog()")}}</li>
	<li>{{domxref("WebGLRenderingContext.getShaderSource()")}}</li>
	<li>{{domxref("WebGLRenderingContext.isProgram()")}}</li>
	<li>{{domxref("WebGLRenderingContext.isShader()")}}</li>
	<li>{{domxref("WebGLRenderingContext.linkProgram()")}}</li>
	<li>{{domxref("WebGLRenderingContext.shaderSource()")}}</li>
	<li>{{domxref("WebGLRenderingContext.useProgram()")}}</li>
	<li>{{domxref("WebGLRenderingContext.validateProgram()")}}</li>
</ul>
